DECLARE SUB SetupNewGame ()
DECLARE SUB Continue ()
DECLARE SUB Credits (clength%, cclr%, cover%, cdelay&, cstart%)
DECLARE SUB Intro ()
DECLARE SUB SideGraphics ()
DECLARE SUB ShowInventory ()
DECLARE SUB WriteStats ()
DECLARE SUB DrawLevel ()
DECLARE SUB ScreenLoad (A$, Filename$)
DECLARE SUB Font (FontDelay&, Words$)
'$DYNAMIC
DEFINT A-Z

DECLARE SUB ScreenLoad2 (Filename$)
DECLARE FUNCTION FileOPEN% (Filename$, Mode$)
DECLARE SUB Delay (LongDelta&)

SUB ColorTitle
	FOR I = 1 TO 202
	  PALETTE I, 65536 * 17 + 256 * 17 + 17
	NEXT I
	ScreenLoad2 "begin.kon"
	FOR I = 1 TO 202
	  PALETTE I, 65536 * 50 + 256 * 50 + 50
	  CurrentTimer! = TIMER
	  WHILE TIMER < (CurrentTimer! + 1D-17): WEND
	  PALETTE I, 65536 * 17 + 256 * 17 + 17
	NEXT I
	PALETTE
	PALETTE 250, 65536 * 50 + 256 * 50 + 50
	COLOR 250
	LOCATE 18, 15: PRINT "PRESENTS..."
	DO: LOOP UNTIL INKEY$ <> "": CLS
END SUB

SUB Credits (clength%, cclr%, cover%, cdelay&, cstart%)
DIM scrolltxt(1 TO 75) AS STRING
CreditFile% = FileOPEN("CREDITS.DAT", "I")
FOR I = 1 TO 24
  LINE INPUT #CreditFile%, scrolltxt$(I)
NEXT I
CLOSE CreditFile%

 cdown% = 24 - cstart%
 cbegin% = 1
 FOR I% = 1 TO clength% - 25
	cdown% = cdown% - 1
	IF cdown% < 1 THEN cdown% = 1
	cupness% = 0
	FOR A% = 0 TO (24 - cdown%)
	 IF cover% = -1 THEN
		covr% = LEN(scrolltxt$(cbegin% + A%)): covr% = (40 - covr%) / 2
	 ELSE
		covr% = cover%
	 END IF
	 IF covr% = 0 THEN covr% = 1
	 COLOR cclr%
	 LOCATE cdown% + cupness%, covr%
	 PRINT scrolltxt$(cbegin% + A%)
	 cupness% = cupness% + 1
	NEXT
	IF cdown% > 1 THEN
	 cbegin% = 1
	ELSE
	 cbegin% = cbegin% + 1
	END IF
	Delay cdelay&
 NEXT I%
END SUB

SUB GameHelp
CLS
PALETTE
CALL ScreenLoad("helppic.pal", "helppic.kon")
key$ = INKEY$
DO: LOOP UNTIL INKEY$ <> ""
CLS
PALETTE
PALETTE 247, 65536 * INT(41) + 256 * INT(0) + INT(0)
PALETTE 246, 65536 * INT(51) + 256 * INT(0) + INT(0)
PALETTE 245, 65536 * INT(61) + 256 * INT(0) + INT(0)
PALETTE 244, 65536 * INT(31) + 256 * INT(0) + INT(0)
PALETTE 243, 65536 * INT(41) + 256 * INT(0) + INT(0)
PALETTE 242, 65536 * INT(51) + 256 * INT(0) + INT(0)
PALETTE 241, 65536 * INT(0) + 256 * INT(0) + INT(31)
PALETTE 240, 65536 * INT(0) + 256 * INT(0) + INT(41)
PALETTE 239, 65536 * INT(0) + 256 * INT(0) + INT(51)

ScreenLoad2 "side.kon"

CALL SideGraphics
CALL ShowInventory
CALL WriteStats
CALL DrawLevel
END SUB

SUB Intro
 fc% = FileOPEN("INTRO.DAT", "I")

 FOR J = 1 TO 4
 LINE (4, 147)-(214, 195), 0, BF
 FOR I = 1 TO 9
   LINE INPUT #fc%, A$
   DRAW A$
   LINE INPUT #fc%, A$
   Font 0, A$
 NEXT I
 DO: LOOP UNTIL INKEY$ <> ""
 NEXT J
 LINE (4, 147)-(214, 195), 0, BF
 CLOSE fc%
END SUB

SUB Menu
	DO
	  keyboard$ = INKEY$
	  SELECT CASE keyboard$
	  CASE "1"
		PALETTE
		ScreenLoad2 "side.kon"
		CALL SetupNewGame
		CALL DrawLevel
		CALL Intro
		EXIT SUB
	  CASE "2"
		CLS
		PALETTE
		CALL Continue
		PALETTE
		ScreenLoad2 "side.kon"
		EXIT SUB
	  CASE "3"
		ScreenLoad "helppic.pal", "helppic.kon"
		key$ = INKEY$: DO: LOOP UNTIL INKEY$ <> "": CLS : PALETTE
		CALL ScreenLoad("menu.pal", "menu.kon")
	  CASE "4"
		CLS : PALETTE: CALL Credits(75, 1, -1, 20, 0): CLS
		CALL ScreenLoad("menu.pal", "menu.kon")
	  CASE "5": SYSTEM
	  END SELECT
	LOOP
END SUB

SUB ObjectKeys (ObjectOver%, ObjectUp%, t%, fcn%)
	fcn% = 0
	keyboard$ = INKEY$
	SELECT CASE keyboard$
	CASE "a"
	  ObjectOver% = 1
	  ObjectUp% = 1
	  fcn% = 1
	CASE "b": ObjectOver% = 2: ObjectUp% = 1: fcn% = 1
	CASE "c": ObjectOver% = 3: ObjectUp% = 1: fcn% = 1
	CASE "d": ObjectOver% = 1: ObjectUp% = 2: fcn% = 1
	CASE "e": ObjectOver% = 2: ObjectUp% = 2: fcn% = 1
	CASE "f": ObjectOver% = 3: ObjectUp% = 2: fcn% = 1
	CASE "g": ObjectOver% = 1: ObjectUp% = 3: fcn% = 1
	CASE "h": ObjectOver% = 2: ObjectUp% = 3: fcn% = 1
	CASE "i": ObjectOver% = 3: ObjectUp% = 3: fcn% = 1
	CASE "j": ObjectOver% = 1: ObjectUp% = 4: fcn% = 1
	CASE "k": ObjectOver% = 2: ObjectUp% = 4: fcn% = 1
	CASE "l": ObjectOver% = 3: ObjectUp% = 4: fcn% = 1
	CASE "m": ObjectOver% = 1: ObjectUp% = 5: fcn% = 1
	CASE "n": ObjectOver% = 2: ObjectUp% = 5: fcn% = 1
	CASE "o": ObjectOver% = 3: ObjectUp% = 5: fcn% = 1
	CASE "p"
	IF t% = 0 OR t% = 5 THEN t% = t% + 5: fcn% = 2
	CASE "q"
	IF t% = 5 OR t% = 10 THEN t% = t% - 5: fcn% = 2
	CASE "0": fcn% = 3
	END SELECT
END SUB

SUB QuitGame
	LINE (4, 147)-(214, 195), 0, BF
	DRAW "BM 6,148 C4 S4": CALL Font(0, "quit(y or n)????")
	DO: key$ = INKEY$: IF key$ = "y" THEN SYSTEM
	LOOP UNTIL key$ = "n"
END SUB

SUB YouDied
LINE (22, 4)-(196, 143), 0, BF: LOCATE 2, 4: PRINT "You died, too bad!": SYSTEM
END SUB

